function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React from 'react';
import { requireNativeComponent, UIManager, findNodeHandle } from 'react-native';
const Commands = {
  // setVideoFlip: 'setVideoFlip',
  startMonitor: 'startMonitor',
  pauseMonitor: 'pauseMonitor',
  replayMonitor: 'replayMonitor',
  stopMonitor: 'stopMonitor',
  destroyMonitor: 'destroyMonitor',
  captureImage: 'captureImage',
  getStreamType: 'getStreamType',
  startVideoRecord: 'startVideoRecord',
  stopVideoRecord: 'stopVideoRecord',
  openVoice: 'openVoice',
  closeVoice: 'closeVoice',
  // depreceated
  // setSpeakerType: 'setSpeakerType',
  startSingleIntercomAndSpeak: 'startSingleIntercomAndSpeak',
  stopSingleIntercomAndSpeak: 'stopSingleIntercomAndSpeak',
  startDoubleIntercom: 'startDoubleIntercom',
  stopDoubleIntercom: 'stopDoubleIntercom',
  switchStreamTypeMonitor: 'switchStreamTypeMonitor',
  setVideoFullScreen: 'setVideoFullScreen',
  capturePicFromDevAndSave: 'capturePicFromDevAndSave',
  seekToTime: 'seekToTime'
};
export const MonitorView = requireNativeComponent('RCTMonitor');
const dispatchCommand = function (viewId, command) {
  let args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  UIManager.dispatchViewManagerCommand(viewId,
  // we are calling the 'setVideoFlip' command
  // UIManager.RCTMonitor.Commands.setVideoFlip,
  // UIManager.RCTMonitor.Commands[command],
  UIManager.getViewManagerConfig('RCTMonitor').Commands[command] || '', args);
};
export class Monitor extends React.Component {
  constructor(props) {
    super(props);
    this.myRef = /*#__PURE__*/React.createRef();
  }

  // flipVideo() {
  //   const viewId = findNodeHandle(this.myRef.current);

  //   if (typeof viewId !== 'number') {
  //     return;
  //   }

  //   dispatchCommand(viewId, Commands.setVideoFlip);
  // }

  playVideo() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.startMonitor);
  }
  pauseVideo() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.pauseMonitor);
  }
  replayVideo() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.replayMonitor);
  }
  stopVideo() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.stopMonitor);
  }
  destroyVideo() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.destroyMonitor);
  }
  getStreamType() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.getStreamType);
  }
  captureImage(path) {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number' || typeof path !== 'string') {
      return;
    }
    dispatchCommand(viewId, Commands.captureImage, [path]);
  }
  startVideoRecord(path) {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number' || typeof path !== 'string') {
      return;
    }
    dispatchCommand(viewId, Commands.startVideoRecord, [path]);
  }
  stopVideoRecord() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.stopVideoRecord);
  }
  openVoice() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.openVoice);
  }
  closeVoice() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.closeVoice);
  }

  // depreceated
  /**
   * set voice changer
   * 0 normal, 1 male ,2 female
   */
  // setSpeakerType(type: 0 | 1 | 2) {
  //   const viewId = findNodeHandle(this.myRef.current);

  //   if (typeof viewId !== 'number') {
  //     return;
  //   }

  //   dispatchCommand(viewId, Commands.setSpeakerType, [type]);
  // }

  startSingleIntercomAndSpeak() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.startSingleIntercomAndSpeak);
  }
  stopSingleIntercomAndSpeak() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.stopSingleIntercomAndSpeak);
  }
  startDoubleIntercom() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.startDoubleIntercom);
  }
  stopDoubleIntercom() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.stopDoubleIntercom);
  }
  switchStreamTypeMonitor() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.switchStreamTypeMonitor);
  }
  setVideoFullScreen(isFullScreen) {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number' || typeof isFullScreen !== 'boolean') {
      return;
    }
    dispatchCommand(viewId, Commands.setVideoFullScreen, [isFullScreen]);
  }
  capturePicFromDevAndSave() {
    const viewId = findNodeHandle(this.myRef.current);
    if (typeof viewId !== 'number') {
      return;
    }
    dispatchCommand(viewId, Commands.capturePicFromDevAndSave);
  }

  // seekToTime() {
  //   const viewId = findNodeHandle(this.myRef.current);
  //   if (typeof viewId !== 'number') {
  //     return;
  //   }

  //   dispatchCommand(viewId, Commands.seekToTime);
  // }

  _onStartInit = () => {
    var _this$props, _this$props2;
    ((_this$props = this.props) === null || _this$props === void 0 ? void 0 : _this$props.onStartInit) && ((_this$props2 = this.props) === null || _this$props2 === void 0 ? void 0 : _this$props2.onStartInit());
  };
  _onMediaPlayState = event => {
    var _this$props3, _this$props4;
    ((_this$props3 = this.props) === null || _this$props3 === void 0 ? void 0 : _this$props3.onMediaPlayState) && ((_this$props4 = this.props) === null || _this$props4 === void 0 ? void 0 : _this$props4.onMediaPlayState(event.nativeEvent));
  };
  _onShowRateAndTime = event => {
    var _this$props5, _this$props6;
    ((_this$props5 = this.props) === null || _this$props5 === void 0 ? void 0 : _this$props5.onShowRateAndTime) && ((_this$props6 = this.props) === null || _this$props6 === void 0 ? void 0 : _this$props6.onShowRateAndTime(event.nativeEvent));
  };
  _onVideoBufferEnd = event => {
    var _this$props7, _this$props8;
    ((_this$props7 = this.props) === null || _this$props7 === void 0 ? void 0 : _this$props7.onVideoBufferEnd) && ((_this$props8 = this.props) === null || _this$props8 === void 0 ? void 0 : _this$props8.onVideoBufferEnd(event.nativeEvent));
  };
  _onFailed = event => {
    var _this$props9, _this$props10;
    ((_this$props9 = this.props) === null || _this$props9 === void 0 ? void 0 : _this$props9.onFailed) && ((_this$props10 = this.props) === null || _this$props10 === void 0 ? void 0 : _this$props10.onFailed(event.nativeEvent));
  };
  _onDebugState = event => {
    var _this$props11, _this$props12;
    ((_this$props11 = this.props) === null || _this$props11 === void 0 ? void 0 : _this$props11.onDebugState) && ((_this$props12 = this.props) === null || _this$props12 === void 0 ? void 0 : _this$props12.onDebugState(event.nativeEvent));
  };
  render() {
    return /*#__PURE__*/React.createElement(MonitorView, _extends({}, this.props, {
      ref: this.myRef,
      onStartInit: this._onStartInit,
      onMediaPlayState: this._onMediaPlayState,
      onShowRateAndTime: this._onShowRateAndTime,
      onVideoBufferEnd: this._onVideoBufferEnd,
      onFailed: this._onFailed,
      onDebugState: this._onDebugState
    }));
  }
}
//# sourceMappingURL=index.js.map